using OpenSource.UPnP;

namespace OpenSource.DeviceBuilder
{
    /// <summary>
    /// Transparent DeviceSide UPnP Service
    /// </summary>
    public class DvremotehelpService : IUPnPService
    {

        // Place your declarations above this line

        #region AutoGenerated Code Section [Do NOT Modify, unless you know what you're doing]
        //{{{{{ Begin Code Block

        private _DvremotehelpService _S;
        public static string URN = "urn:schemas-upnp-org:service:remotehelpService:1";
        public double VERSION
        {
           get
           {
               return(double.Parse(_S.GetUPnPService().Version));
           }
        }

        public delegate void OnStateVariableModifiedHandler(DvremotehelpService sender);
        public event OnStateVariableModifiedHandler OnStateVariableModified_sendedT;
        public event OnStateVariableModifiedHandler OnStateVariableModified_is_Open_CAM;
        public event OnStateVariableModifiedHandler OnStateVariableModified_isLogin;
        public event OnStateVariableModifiedHandler OnStateVariableModified_Message;
        public System.String sendedT
        {
            get
            {
               return((System.String)_S.GetStateVariable("sendedT"));
            }
            set
            {
               _S.SetStateVariable("sendedT", value);
            }
        }
        public System.Boolean is_Open_CAM
        {
            get
            {
               return((System.Boolean)_S.GetStateVariable("is_Open_CAM"));
            }
            set
            {
               _S.SetStateVariable("is_Open_CAM", value);
            }
        }
        public System.Boolean isLogin
        {
            get
            {
               return((System.Boolean)_S.GetStateVariable("isLogin"));
            }
            set
            {
               _S.SetStateVariable("isLogin", value);
            }
        }
        public System.String Message
        {
            get
            {
               return((System.String)_S.GetStateVariable("Message"));
            }
            set
            {
               _S.SetStateVariable("Message", value);
            }
        }
        public UPnPModeratedStateVariable.IAccumulator Accumulator_sendedT
        {
            get
            {
                 return(((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("sendedT")).Accumulator);
            }
            set
            {
                 ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("sendedT")).Accumulator = value;
            }
        }
        public double ModerationDuration_sendedT
        {
            get
            {
                 return(((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("sendedT")).ModerationPeriod);
            }
            set
            {
                 ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("sendedT")).ModerationPeriod = value;
            }
        }
        public UPnPModeratedStateVariable.IAccumulator Accumulator_is_Open_CAM
        {
            get
            {
                 return(((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("is_Open_CAM")).Accumulator);
            }
            set
            {
                 ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("is_Open_CAM")).Accumulator = value;
            }
        }
        public double ModerationDuration_is_Open_CAM
        {
            get
            {
                 return(((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("is_Open_CAM")).ModerationPeriod);
            }
            set
            {
                 ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("is_Open_CAM")).ModerationPeriod = value;
            }
        }
        public UPnPModeratedStateVariable.IAccumulator Accumulator_isLogin
        {
            get
            {
                 return(((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("isLogin")).Accumulator);
            }
            set
            {
                 ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("isLogin")).Accumulator = value;
            }
        }
        public double ModerationDuration_isLogin
        {
            get
            {
                 return(((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("isLogin")).ModerationPeriod);
            }
            set
            {
                 ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("isLogin")).ModerationPeriod = value;
            }
        }
        public UPnPModeratedStateVariable.IAccumulator Accumulator_Message
        {
            get
            {
                 return(((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("Message")).Accumulator);
            }
            set
            {
                 ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("Message")).Accumulator = value;
            }
        }
        public double ModerationDuration_Message
        {
            get
            {
                 return(((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("Message")).ModerationPeriod);
            }
            set
            {
                 ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("Message")).ModerationPeriod = value;
            }
        }
        public delegate void Delegate_getLogin(out System.Boolean Arg1);
        public delegate void Delegate_getSendedT(out System.String Arg1);
        public delegate void Delegate_getStateCAM(out System.Boolean Arg1);
        public delegate void Delegate_setLogin(System.Boolean Arg1, out System.String Arg2);
        public delegate void Delegate_setMessqge(System.String Arg1);
        public delegate void Delegate_setStateCAM(System.Boolean Arg1, out System.String Arg2);

        public Delegate_getLogin External_getLogin = null;
        public Delegate_getSendedT External_getSendedT = null;
        public Delegate_getStateCAM External_getStateCAM = null;
        public Delegate_setLogin External_setLogin = null;
        public Delegate_setMessqge External_setMessqge = null;
        public Delegate_setStateCAM External_setStateCAM = null;

        public void RemoveStateVariable_sendedT()
        {
            _S.GetUPnPService().RemoveStateVariable(_S.GetUPnPService().GetStateVariableObject("sendedT"));
        }
        public void RemoveStateVariable_is_Open_CAM()
        {
            _S.GetUPnPService().RemoveStateVariable(_S.GetUPnPService().GetStateVariableObject("is_Open_CAM"));
        }
        public void RemoveStateVariable_isLogin()
        {
            _S.GetUPnPService().RemoveStateVariable(_S.GetUPnPService().GetStateVariableObject("isLogin"));
        }
        public void RemoveStateVariable_Message()
        {
            _S.GetUPnPService().RemoveStateVariable(_S.GetUPnPService().GetStateVariableObject("Message"));
        }
        public void RemoveAction_getLogin()
        {
             _S.GetUPnPService().RemoveMethod("getLogin");
        }
        public void RemoveAction_getSendedT()
        {
             _S.GetUPnPService().RemoveMethod("getSendedT");
        }
        public void RemoveAction_getStateCAM()
        {
             _S.GetUPnPService().RemoveMethod("getStateCAM");
        }
        public void RemoveAction_setLogin()
        {
             _S.GetUPnPService().RemoveMethod("setLogin");
        }
        public void RemoveAction_setMessqge()
        {
             _S.GetUPnPService().RemoveMethod("setMessqge");
        }
        public void RemoveAction_setStateCAM()
        {
             _S.GetUPnPService().RemoveMethod("setStateCAM");
        }
        public System.Net.IPEndPoint GetCaller()
        {
             return(_S.GetUPnPService().GetCaller());
        }
        public System.Net.IPEndPoint GetReceiver()
        {
             return(_S.GetUPnPService().GetReceiver());
        }

        private class _DvremotehelpService
        {
            private DvremotehelpService Outer = null;
            private UPnPService S;
            internal _DvremotehelpService(DvremotehelpService n)
            {
                Outer = n;
                S = BuildUPnPService();
            }
            public UPnPService GetUPnPService()
            {
                return(S);
            }
            public void SetStateVariable(string VarName, object VarValue)
            {
               S.SetStateVariable(VarName,VarValue);
            }
            public object GetStateVariable(string VarName)
            {
               return(S.GetStateVariable(VarName));
            }
            protected UPnPService BuildUPnPService()
            {
                UPnPStateVariable[] RetVal = new UPnPStateVariable[4];
                RetVal[0] = new UPnPModeratedStateVariable("sendedT", typeof(System.String), false);
                RetVal[0].AddAssociation("getSendedT", "Arg1");
                RetVal[0].AddAssociation("setMessqge", "Arg1");
                RetVal[1] = new UPnPModeratedStateVariable("is_Open_CAM", typeof(System.Boolean), false);
                RetVal[1].AddAssociation("getStateCAM", "Arg1");
                RetVal[1].AddAssociation("setStateCAM", "Arg1");
                RetVal[2] = new UPnPModeratedStateVariable("isLogin", typeof(System.Boolean), false);
                RetVal[2].AddAssociation("getLogin", "Arg1");
                RetVal[2].AddAssociation("setLogin", "Arg1");
                RetVal[3] = new UPnPModeratedStateVariable("Message", typeof(System.String), false);
                RetVal[3].AddAssociation("setLogin", "Arg2");
                RetVal[3].AddAssociation("setStateCAM", "Arg2");

                UPnPService S = new UPnPService(1, "urn:upnp-org:serviceId:remotehelpService", URN, true, this);
                for(int i=0;i<RetVal.Length;++i)
                {
                   S.AddStateVariable(RetVal[i]);
                }
                S.AddMethod("getLogin");
                S.AddMethod("getSendedT");
                S.AddMethod("getStateCAM");
                S.AddMethod("setLogin");
                S.AddMethod("setMessqge");
                S.AddMethod("setStateCAM");
                return(S);
            }

            public void getLogin(out System.Boolean Arg1)
            {
                if (Outer.External_getLogin != null)
                {
                    Outer.External_getLogin(out Arg1);
                }
                else
                {
                    Sink_getLogin(out Arg1);
                }
            }
            public void getSendedT(out System.String Arg1)
            {
                if (Outer.External_getSendedT != null)
                {
                    Outer.External_getSendedT(out Arg1);
                }
                else
                {
                    Sink_getSendedT(out Arg1);
                }
            }
            public void getStateCAM(out System.Boolean Arg1)
            {
                if (Outer.External_getStateCAM != null)
                {
                    Outer.External_getStateCAM(out Arg1);
                }
                else
                {
                    Sink_getStateCAM(out Arg1);
                }
            }
            public void setLogin(System.Boolean Arg1, out System.String Arg2)
            {
                if (Outer.External_setLogin != null)
                {
                    Outer.External_setLogin(Arg1, out Arg2);
                }
                else
                {
                    Sink_setLogin(Arg1, out Arg2);
                }
            }
            public void setMessqge(System.String Arg1)
            {
                if (Outer.External_setMessqge != null)
                {
                    Outer.External_setMessqge(Arg1);
                }
                else
                {
                    Sink_setMessqge(Arg1);
                }
            }
            public void setStateCAM(System.Boolean Arg1, out System.String Arg2)
            {
                if (Outer.External_setStateCAM != null)
                {
                    Outer.External_setStateCAM(Arg1, out Arg2);
                }
                else
                {
                    Sink_setStateCAM(Arg1, out Arg2);
                }
            }

            public Delegate_getLogin Sink_getLogin;
            public Delegate_getSendedT Sink_getSendedT;
            public Delegate_getStateCAM Sink_getStateCAM;
            public Delegate_setLogin Sink_setLogin;
            public Delegate_setMessqge Sink_setMessqge;
            public Delegate_setStateCAM Sink_setStateCAM;
        }
        public DvremotehelpService()
        {
            _S = new _DvremotehelpService(this);
            _S.GetUPnPService().GetStateVariableObject("sendedT").OnModified += new UPnPStateVariable.ModifiedHandler(OnModifiedSink_sendedT);
            _S.GetUPnPService().GetStateVariableObject("is_Open_CAM").OnModified += new UPnPStateVariable.ModifiedHandler(OnModifiedSink_is_Open_CAM);
            _S.GetUPnPService().GetStateVariableObject("isLogin").OnModified += new UPnPStateVariable.ModifiedHandler(OnModifiedSink_isLogin);
            _S.GetUPnPService().GetStateVariableObject("Message").OnModified += new UPnPStateVariable.ModifiedHandler(OnModifiedSink_Message);
            _S.Sink_getLogin = new Delegate_getLogin(getLogin);
            _S.Sink_getSendedT = new Delegate_getSendedT(getSendedT);
            _S.Sink_getStateCAM = new Delegate_getStateCAM(getStateCAM);
            _S.Sink_setLogin = new Delegate_setLogin(setLogin);
            _S.Sink_setMessqge = new Delegate_setMessqge(setMessqge);
            _S.Sink_setStateCAM = new Delegate_setStateCAM(setStateCAM);
        }
        public DvremotehelpService(string ID):this()
        {
            _S.GetUPnPService().ServiceID = ID;
        }
        public UPnPService GetUPnPService()
        {
            return(_S.GetUPnPService());
        }
        private void OnModifiedSink_sendedT(UPnPStateVariable sender, object NewValue)
        {
            if (OnStateVariableModified_sendedT != null) OnStateVariableModified_sendedT(this);
        }
        private void OnModifiedSink_is_Open_CAM(UPnPStateVariable sender, object NewValue)
        {
            if (OnStateVariableModified_is_Open_CAM != null) OnStateVariableModified_is_Open_CAM(this);
        }
        private void OnModifiedSink_isLogin(UPnPStateVariable sender, object NewValue)
        {
            if (OnStateVariableModified_isLogin != null) OnStateVariableModified_isLogin(this);
        }
        private void OnModifiedSink_Message(UPnPStateVariable sender, object NewValue)
        {
            if (OnStateVariableModified_Message != null) OnStateVariableModified_Message(this);
        }
        //}}}}} End of Code Block

        #endregion

        /// <summary>
        /// Action: getLogin
        /// </summary>
        /// <param name="Arg1">Associated State Variable: isLogin</param>
        public void getLogin(out System.Boolean Arg1)
        {
            //ToDo: Add Your implementation here, and remove exception
            throw(new UPnPCustomException(800,"This method has not been completely implemented..."));
        }
        /// <summary>
        /// Action: getSendedT
        /// </summary>
        /// <param name="Arg1">Associated State Variable: sendedT</param>
        public void getSendedT(out System.String Arg1)
        {
            //ToDo: Add Your implementation here, and remove exception
            throw(new UPnPCustomException(800,"This method has not been completely implemented..."));
        }
        /// <summary>
        /// Action: getStateCAM
        /// </summary>
        /// <param name="Arg1">Associated State Variable: is_Open_CAM</param>
        public void getStateCAM(out System.Boolean Arg1)
        {
            //ToDo: Add Your implementation here, and remove exception
            throw(new UPnPCustomException(800,"This method has not been completely implemented..."));
        }
        /// <summary>
        /// Action: setLogin
        /// </summary>
        /// <param name="Arg1">Associated State Variable: isLogin</param>
        /// <param name="Arg2">Associated State Variable: Message</param>
        public void setLogin(System.Boolean Arg1, out System.String Arg2)
        {
            //ToDo: Add Your implementation here, and remove exception
            throw(new UPnPCustomException(800,"This method has not been completely implemented..."));
        }
        /// <summary>
        /// Action: setMessqge
        /// </summary>
        /// <param name="Arg1">Associated State Variable: sendedT</param>
        public void setMessqge(System.String Arg1)
        {
            //ToDo: Add Your implementation here, and remove exception
            throw(new UPnPCustomException(800,"This method has not been completely implemented..."));
        }
        /// <summary>
        /// Action: setStateCAM
        /// </summary>
        /// <param name="Arg1">Associated State Variable: is_Open_CAM</param>
        /// <param name="Arg2">Associated State Variable: Message</param>
        public void setStateCAM(System.Boolean Arg1, out System.String Arg2)
        {
            //ToDo: Add Your implementation here, and remove exception
            throw(new UPnPCustomException(800,"This method has not been completely implemented..."));
        }
    }
}